using FluentValidation;
using CMSMicroservice.Protobuf.Protos.ProductImages;
namespace CMSMicroservice.Protobuf.Validator.ProductImages;

public class GetAllProductImagesByFilterRequestValidator : AbstractValidator<GetAllProductImagesByFilterRequest>
{
    public GetAllProductImagesByFilterRequestValidator()
    {
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetAllProductImagesByFilterRequest>.CreateWithOptions((GetAllProductImagesByFilterRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
